// Version 0.8b

package IPC {

	function ToggleIPCGui(%val) {
		if (%val)
			{
			if (isObject(IPCGui))
				IPCGuiDestroy();
			else {
				IPCGuiCreate();
				GlobalActionMap.copyBind(moveMap, ToggleIPCGui);
			}
		}
	}


	function OptionsDlg::onWake(%this) {
		if ($IPCGuiBind $= "false") {
			$RemapName[$RemapCount] = "Toggle IPC Gui";
			$RemapCmd[$RemapCount]  = "ToggleIPCGui";
			$RemapCount++;
			$IPCGuiBind = "true";
		}

		if($pref::IPC::Voices $= "")
			IPCVoicesOff();

		parent::onWake(%this);
	}


	function DispatchLaunchMode() {
		addMessageCallback('MsgCTFFlagCapped', IPCFlagLost);
		addMessageCallback('MsgCTFFlagDropped', IPCFlagLost);
		addMessageCallback('MsgCTFFlagReturned', IPCFlagLost);
		addMessageCallback('MsgCTFFlagTaken', IPCFlagTaken);
		addMessageCallback('MsgClientDrop', IPCPlayerChange);
		addMessageCallback('MsgClientJoinTeam', IPCPlayerChange);
		addMessageCallback('MsgGameOver', IPCReset);

		parent::DispatchLaunchMode();
	}

	function IPCVoicesOn() {
		$pref::IPC::Voices = 1;
	}

	function IPCVoicesOff() {
		$pref::IPC::Voices = 0;
	}

	function IPCGetClientName(%clientId) {
		%player = $PlayerList[%clientId];
		return %player.name;
	}


	function IPCMatchPlayerByName(%playername) {
		%returnme = -1;
		for(%x = 0; %x < $IPCMaxPlayers; %x++) {
			if($IPCplayer[%x] $= %playername) {
				%returnme = %x;
				break;
			}
		}
		return %returnme;
	}


	function IPCWhoHasFlag() {
		%returnme = -1;
		for(%x = 0; %x <= $IPCMaxPlayers; %x++) {
			if($IPCflag[%x] $= "1") {
				%returnme = %x;
				break;
			}
		}
		return %returnme;
	}


	function IPCAddPlayer(%clientId, %force) {
		%player = $PlayerList[%clientId];
		%teamName = $clTeamScore[%player.teamId, 0] $= "" ? "-" : $clTeamScore[%player.teamId, 0];
		if(%force == 1)
			%teamName = $IPCMyTeam;
		if (%teamName !$= $IPCMyTeam)
			return -1;
	
	
		for(%x = 0; %x <= ($IPCMaxPlayers+1); %x++) {
			if($IPCplayer[%x] $= "") {
				$IPCplayer[%x] = %playername;
				break;
			}
		}
		if (%x > $IPCMaxPlayers)
			return -1;
		else
			return %x;
	}


	function IPCPlayerChange(%msgType, %msgString, %clientName, %teamName, %clientId, %teamId) {
		if((strpos(%msgString, "You joined the") != -1) || (%clientName $= "")) {
			IPCReset();
			$IPCMyTeam = detag(%teamName);
		}
		else
			IPCRemovePlayer(detag(%clientName));
	}
    
    
	function IPCRemovePlayer(%clientName) {
		%x = IPCMatchPlayerByName(%clientName);
		if(%x != -1) {
			$IPCflag[%x] = "";
			$IPCplayer[%x] = "";
			$IPCarmor[%x] = "";
			$IPCpack[%x] = "";
			$IPCobjective[%x] = "";
			$IPCaddr[%x] = "";
			$IPCline[%x] = "";
			if (isObject(IPCGui))
				IPCGuiCreate();
		}
	}

	function IPCLinePlayerCheck(%x) {
		if(!isObject(IPCGui))
			return 0;

		if($IPCPlayer[%x] $= $IPCGui.Player[ $IPCline[%x] ].text)
			return 1;
		else
			return 0;
	}


	function IPCUpdatePlayer(%x, %Flag, %Name, %Armor, %Pack, %Objective, %ADDR) {
		if(%Name !$= "") {
			if(%Name !$= $IPCplayer[%x]) {
				$IPCplayer[%x] = %Name;
				if(isObject(IPCGui))
					IPCGui.Player[ $IPCline[%x] ].setText(%Name);
			}
		}
		if(%Flag !$= "") {
			if($IPCflag[%x] !$= %Flag) {
				$IPCflag[%x] = %Flag;
				if(IPCLinePlayerCheck(%x) == 1) {
					IPCGui.Flag[ $IPCline[%x] ].visible = %Flag;
				}
			}
		}
		if(%Armor !$= "") {
			if(%Armor !$= $IPCarmor[%x]) {
				$IPCarmor[%x] = %Armor;
				if(IPCLinePlayerCheck(%x) == 1)
					IPCGui.Armor[ $IPCline[%x] ].setText(%Armor);
			}
		}
		if(%Pack !$= "") {
			if(%Pack !$= $IPCpack[%x]) {
				if(%Pack $= "IPCNULL") {
					$IPCpack[%x] = "";
					if(IPCLinePlayerCheck(%x) == 1)
						IPCGui.Pack[ $IPCline[%x] ].setBitmap("");
				}				
				else {
					$IPCpack[%x] = %Pack;
					if(IPCLinePlayerCheck(%x) == 1)
						IPCGui.Pack[ $IPCline[%x] ].setBitmap(%Pack @ ".png");
				}
			}
		}
 		if(%ADDR !$= "") {
			if(%ADDR !$= $IPCaddr[%x]) {
				$IPCaddr[%x] = %ADDR;
				if (isObject(IPCGui))
					IPCGuiCreate();
			}
		}
		if(%Objective !$= "") {
			if(%Objective !$= $IPCobjective[%x]) {
				$IPCobjective[%x] = %Objective;
				if(IPCLinePlayerCheck(%x) == 1)
					IPCGui.Objective[ $IPCline[%x] ].setText(%Objective);
			}
		}

	}


	function clientCmdCannedChatMessage( %sender, %msgString, %name, %string, %keys, %voiceTag, %pitch ) {
		%playername = IPCgetClientName(%sender);
		%x = IPCMatchPlayerByName(%playername);
		if (%x == -1)
			%x = IPCAddPlayer(%sender, 0);

		if (%x != -1) {	
			switch$ (%keys)
			{
				case "VSAA":
					IPCUpdatePlayer(%x,"",%playername,"","","Attack","Attacking");
				case "VSAB":
					IPCUpdatePlayer(%x,"",%playername,"","","Base","Attacking");
				case "VSAF":
					IPCUpdatePlayer(%x,"",%playername,"","","Flag","Attacking");
				case "VSAG":
					IPCUpdatePlayer(%x,"",%playername,"","","Generators","Attacking");
				case "VSAS":
					IPCUpdatePlayer(%x,"",%playername,"","","Sensors","Attacking");
				case "VSAT":
					IPCUpdatePlayer(%x,"",%playername,"","","Turrets","Attacking");
				case "VSAV":
					IPCUpdatePlayer(%x,"",%playername,"","","Vehicle Bay","Attacking");


				case "VSDB":
					IPCUpdatePlayer(%x,"",%playername,"","","Base","Defending");
				case "VSDD":
					IPCUpdatePlayer(%x,"",%playername,"","","Defend","Defending");
				case "VSDF":
					IPCUpdatePlayer(%x,"",%playername,"","","Flag","Defending");
				case "VSDG":
					IPCUpdatePlayer(%x,"",%playername,"","","Generators","Defending");
				case "VSDS":
					IPCUpdatePlayer(%x,"",%playername,"","","Sensors","Defending");
				case "VSDT":
					IPCUpdatePlayer(%x,"",%playername,"","","Turrets","Defending");
				case "VSDV":
					IPCUpdatePlayer(%x,"",%playername,"","","Vehicle Bay","Defending");


				case "VSRB":
					IPCUpdatePlayer(%x,"",%playername,"","","Base","Repairing");
				case "VSRE":
					IPCUpdatePlayer(%x,"",%playername,"","","Equipment","Repairing");
				case "VSRG":
					IPCUpdatePlayer(%x,"",%playername,"","","Generators","Repairing");
				case "VSRR":
					IPCUpdatePlayer(%x,"",%playername,"","","Repairing","Repairing");
				case "VSRS":
					IPCUpdatePlayer(%x,"",%playername,"","","Sensors","Repairing");
				case "VSRT":
					IPCUpdatePlayer(%x,"",%playername,"","","Turrets","Repairing");
				case "VSRV":
					IPCUpdatePlayer(%x,"",%playername,"","","Vehicle Bay","Repairing");


				case "VSTD":
					IPCUpdatePlayer(%x,"",%playername,"","","Defenses","Deploying");
				case "VSTR":
					IPCUpdatePlayer(%x,"",%playername,"","","Remotes","Deploying");
				case "VSTS":
					IPCUpdatePlayer(%x,"",%playername,"","","Sensors","Deploying");
				case "VSTT":
					IPCUpdatePlayer(%x,"",%playername,"","","Turrets","Deploying");
				case "VSTD":
					IPCUpdatePlayer(%x,"",%playername,"","","Defenses","Deploying");


				case "VNB":
					IPCUpdatePlayer(%x,"",%playername,"","","Bombardier","Needs");
				case "VNC":
					IPCUpdatePlayer(%x,"",%playername,"","","Cover","Needs");
				case "VND":
					IPCUpdatePlayer(%x,"",%playername,"","","Driver","Needs");
				case "VNE":
					IPCUpdatePlayer(%x,"",%playername,"","","Escort","Needs");
				case "VNG":
					IPCUpdatePlayer(%x,"",%playername,"","","Gunship Ready","Needs");
				case "VNH":
					IPCUpdatePlayer(%x,"",%playername,"","","Hold Vehicle","Needs");
				case "VNP":
					IPCUpdatePlayer(%x,"",%playername,"","","Pilot","Needs");
				case "VNR":
					IPCUpdatePlayer(%x,"",%playername,"","","Ride","Needs");
				case "VNS":
					IPCUpdatePlayer(%x,"",%playername,"","","Support","Needs");
				case "VNT":
					IPCUpdatePlayer(%x,"",%playername,"","","Tailgunner","Needs");
				case "VNW":
					IPCUpdatePlayer(%x,"",%playername,"","","Where To?","Needs");

				default:
					parent::clientCmdCannedChatMessage( %sender, %msgString, %name, %string, %keys, %voiceTag, %pitch );
					return 0;
			}

		if ($pref::IPC::Voices == 1)
			parent::clientCmdCannedChatMessage( %sender, %msgString, %name, %string, %keys, %voiceTag, %pitch ); 
		}
		else
			parent::clientCmdCannedChatMessage( %sender, %msgString, %name, %string, %keys, %voiceTag, %pitch );
	}


	function clientCmdChatMessage(%sender, %voice, %pitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10) {
		%echo = 1;
		%playername = IPCgetClientName(%sender);
		%x = IPCMatchPlayerByName(%playername);
		if (%x == -1)
			%x = IPCAddPlayer(%playername, 0);

		if (%x != -1) {
			if(strpos(%a2, "Scout") != -1) {
				IPCUpdatePlayer(%x,"",%playername,"L","","","");
				%echo = 0;
			}
			else
				if(strpos(%a2, "Assault") != -1) {
					IPCUpdatePlayer(%x,"",%playername,"M","","","");
					%echo = 0;
				}
			else
				if(strpos(%a2, "Juggernaut") != -1) {
					IPCUpdatePlayer(%x,"",%playername,"H","","","");
					%echo = 0;
				}

			//### Start on Packs

			if(strpos(%a2, "EnergyPack") != -1) {
				IPCUpdatePlayer(%x,"",%playername,"","EnergyPack","","");
				%echo = 0;
			}

			else if(strpos(%a2, "RepairPack") != -1) {
				IPCUpdatePlayer(%x,"",%playername,"","RepairPack","","");
				%echo = 0;
			}

			else if(strpos(%a2, "ShieldPack") != -1) {
				IPCUpdatePlayer(%x,"",%playername,"","ShieldPack","","");
				%echo = 0;
			}

			else if(strpos(%a2, "CloakingPack") != -1) {
				IPCUpdatePlayer(%x,"",%playername,"","CloakingPack","","");
				%echo = 0;
			}

			else if(strpos(%a2, "SensorJammerPack") != -1) {
				IPCUpdatePlayer(%x,"",%playername,"","SensorJammerPack","","");
				%echo = 0;
			}

			else if(strpos(%a2, "AmmoPack") != -1) {
				IPCUpdatePlayer(%x,"",%playername,"","AmmoPack","","");
				%echo = 0;
			}

			else if(strpos(%a2, "SatchelCharge") != -1) {
				IPCUpdatePlayer(%x,"",%playername,"","SatchelCharge","","");
				%echo = 0;
			}

			else if(strpos(%a2, "MotionSensorDeployable") != -1) {
				IPCUpdatePlayer(%x,"",%playername,"","MotionSensorDeployable","","");
				%echo = 0;
			}

			else if(strpos(%a2, "PulseSensorDeployable") != -1) {
				IPCUpdatePlayer(%x,"",%playername,"","PulseSensorDeployable","","");
				%echo = 0;
			}

			else if(strpos(%a2, "InventoryDeployable") != -1) {
				IPCUpdatePlayer(%x,"",%playername,"","InventoryDeployable","","");
				%echo = 0;
			}

			else if(strpos(%a2, "TurretOutdoorDeployable") != -1) {
				IPCUpdatePlayer(%x,"",%playername,"","TurretOutdoorDeployable","","");
				%echo = 0;
			}

			else if(strpos(%a2, "TurretIndoorDeployable") != -1) {
				IPCUpdatePlayer(%x,"",%playername,"","TurretIndoorDeployable","","");
				%echo = 0;
			}

			else if(strpos(%a2, "BarrelPack") != -1) {
				IPCUpdatePlayer(%x,"",%playername,"","BarrelPack","","");
				%echo = 0;
			}

			else if(strpos(%a2, "Echo IPC Version") != -1 && strpos(%playername, "Advis") != -1) {
				commandToServer('messageSent', "Using IPC Version " @ $IPCVersion);
				%echo = 0;
			}

			else
				if(%echo == 1)
					parent::clientCmdChatMessage(%sender, %voice, %pitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10);
		}
		else
			parent::clientCmdChatMessage(%sender, %voice, %pitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10);
	}


	function defaultMessageCallback(%msgType, %msgString, %victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType) {
		if(strpos(%msgType, "Kill") != -1 || strpos(%msgType, "Suicide") != -1) {
			%returnme = -1;
			for(%x = 0; %x <= $IPCMaxPlayers; %x++) {
				if($IPCplayer[%x] $= detag(%victimName)) {
					%returnme = %x;
					break;
				}
			}

			if(%returnme != -1)
				IPCUpdatePlayer(%returnme,"","","L","IPCNULL","","");
		}
		
		parent::defaultMessageCallback(%msgType, %msgString, %victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType); 
	}
			

	function IPCFlagTaken(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6) {
		if($IPCMyteam !$= detag(%a2) && detag(%a2) !$= "0") {
			%playername = detag(%a1);
			%x = IPCMatchPlayerByName(%playername);
			if (%x == -1)
				%x = IPCAddPlayer(%playername, 1);

			if (%x != -1)
				IPCUpdatePlayer(%x,"1",%playername,"","","","");
		}
	}


	function IPCFlagLost(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6) {
		if($IPCMyteam !$= detag(%a2) && detag(%a2) !$= "0") {
			%x = IPCWhoHasFlag();
			if (%x != -1)
				IPCUpdatePlayer(%x,"0","","","","","");
		}
	}   


	function loadFavorite(%index, %echo) {
		parent::loadFavorite(%index, %echo);

		%favString = $pref::Favorite[%index];

		for(%x = 0; %x !=3; %x++) {
			if(strpos(%favString, $InvArmor[%x]) != -1) {
				$IPCMyLoadout = $InvArmor[%x];
				break;
			}
		}
	}


	function clientCmdSetBackpackHudItem(%num, %addItem) {
		parent::clientCmdSetBackpackHudItem(%num, %addItem);

		if(%addItem) {
			$IPCMyPack = $BackpackHudData[%num, itemDataName];
			commandToServer('TeamMessageSent', "Using " @ $IPCMyLoadout @ " class armor with " @ $IPCMyPack);
		}

	}


	function IPCDump() {
		cls();
		for(%x = 0; %x != ($IPCMaxPlayers + 1); %x++) {
			echo("%x = " @ %x @ 
				" F: " @ $IPCflag[%x] @
				" P: " @ $IPCplayer[%x] @
				" A: " @ $IPCarmor[%x] @
				" P: " @ $IPCpack[%x] @
				" O: " @ $IPCobjective[%x] @
				" L: " @ $IPCline[%x] @
				" A: " @ $IPCaddr[%x]);
		}
	}


	function IPCReset() {
		for(%x = 0; %x != ($IPCMaxPlayers + 1); %x++) {
			$IPCflag[%x] = "";
			$IPCplayer[%x] = "";
			$IPCarmor[%x] = "";
			$IPCpack[%x] = "";
			$IPCobjective[%x] = "";
			$IPCaddr[%x] = "";
			$IPCline[%x] = "";
		}
		$IPCMyTeam = "";
		if (isObject(IPCGui))
			IPCGuiCreate();
	}


	function IPCDisplayAll() {
		%x = 0;

		IPCGui.Attacking.position = "0 0";
		%x = IPCSortAttacking();
		IPCGui.Defending.position = "0 " @ (%x*16);
		%x = IPCSortDefending(%x);
		IPCGui.Deploying.position = "0 " @ (%x*16);
		%x = IPCSortDeploying(%x);
		IPCGui.Repairing.position = "0 " @ (%x*16);
		%x = IPCSortRepairing(%x);
		IPCGui.Needs.position = "0 " @ (%x*16);
		%x = IPCSortNeeds(%x);

		for(%x = 0; %x <= ($IPCMaxPlayers + 5); %x++) {
			if($IPCline[%x] !$= "") {
				if($IPCaddr[%x] !$= "")
					IPCCreateLine($IPCline[%x], $IPCflag[%x], $IPCplayer[%x], $IPCarmor[%x], $IPCpack[%x], $IPCobjective[%x]);
			}
		}
	}


	function IPCSortAttacking (%TitleLine) {
		%a = 0;
		%nexttitle = 0;

		for(%x = 0; %x <= $IPCMaxPlayers; %x++) {
			if ($IPCaddr[%x] $= "Attacking") {
				%exs[%a] = %x;			
				%a++;
			}	
		}

		if(%a == 0)
			return (%TitleLine + 1);

		for(%x = 0; %x <= %a; %x++) {
			%check = $IPCplayer[ %exs[%x] ];
			%greaterthan = 0;			
			
			for(%y = 0; %y < %a; %y++) {
				if(strcmp(%check, $IPCplayer[ %exs[%y] ]) > 0)
					%greaterthan++;
			}

			%greaterthan = %greaterthan + (%TitleLine + 1); 
			if(%greaterthan > %nexttitle)
				%nexttitle = %greaterthan;			

			$IPCline[ %exs[%x] ] = %greaterthan;
		}
		return %nexttitle + 1;
	}


	function IPCSortDefending (%TitleLine) {
		%a = 0;
		%nexttitle = 0;

		for(%x = 0; %x <= $IPCMaxPlayers; %x++) {
			if ($IPCaddr[%x] $= "Defending") {
				%exs[%a] = %x;			
				%a++;
			}	
		}

		if(%a == 0)
			return (%TitleLine + 1);

		for(%x = 0; %x <= %a; %x++) {
			%check = $IPCplayer[ %exs[%x] ];
			%greaterthan = 0;			
			
			for(%y = 0; %y < %a; %y++) {
				if(strcmp(%check, $IPCplayer[ %exs[%y] ]) > 0)
					%greaterthan++;
			}

			%greaterthan = %greaterthan + (%TitleLine + 1);
			if(%greaterthan > %nexttitle)
				%nexttitle = %greaterthan;			

			$IPCline[ %exs[%x] ] = %greaterthan;
		}
		return %nexttitle + 1;
	}


	function IPCSortDeploying (%TitleLine) {
		%a = 0;
		%nexttitle = 0;

		for(%x = 0; %x <= $IPCMaxPlayers; %x++) {
			if ($IPCaddr[%x] $= "Deploying") {
				%exs[%a] = %x;			
				%a++;
			}
		}

		if(%a == 0)
			return (%TitleLine + 1);

		for(%x = 0; %x <= %a; %x++) {
			%check = $IPCplayer[ %exs[%x] ];
			%greaterthan = 0;			
			
			for(%y = 0; %y < %a; %y++) {
				if(strcmp(%check, $IPCplayer[ %exs[%y] ]) > 0)
					%greaterthan++;
			}

			%greaterthan = %greaterthan + (%TitleLine + 1); 
			if(%greaterthan > %nexttitle)
				%nexttitle = %greaterthan;			

			$IPCline[ %exs[%x] ] = %greaterthan;
		}
		return %nexttitle + 1;
	}


	function IPCSortRepairing (%TitleLine) {
		%a = 0;
		%nexttitle = 0;

		for(%x = 0; %x <= $IPCMaxPlayers; %x++) {
			if ($IPCaddr[%x] $= "Repairing") {
				%exs[%a] = %x;			
				%a++;
			}	
		}

		if(%a == 0)
			return (%TitleLine + 1);

		for(%x = 0; %x <= %a; %x++) {
			%check = $IPCplayer[ %exs[%x] ];
			%greaterthan = 0;			
			
			for(%y = 0; %y < %a; %y++) {
				if(strcmp(%check, $IPCplayer[ %exs[%y] ]) > 0)
					%greaterthan++;
			}

			%greaterthan = %greaterthan + (%TitleLine + 1);
			if(%greaterthan > %nexttitle)
				%nexttitle = %greaterthan;			

			$IPCline[ %exs[%x] ] = %greaterthan;
		}
		return %nexttitle + 1;
	}


	function IPCSortNeeds (%TitleLine) {
		%a = 0;
		%nexttitle = 0;

		for(%x = 0; %x <= $IPCMaxPlayers; %x++) {
			if ($IPCaddr[%x] $= "Needs") {
				%exs[%a] = %x;			
				%a++;
			}	
		}

		if(%a == 0)
			return (%TitleLine + 1);

		for(%x = 0; %x <= %a; %x++) {
			%check = $IPCplayer[ %exs[%x] ];
			%greaterthan = 0;			
			
			for(%y = 0; %y < %a; %y++) {
				if(strcmp(%check, $IPCplayer[ %exs[%y] ]) > 0)
					%greaterthan++;
			}

			%greaterthan = %greaterthan + (%TitleLine + 1);
			if(%greaterthan > %nexttitle)
				%nexttitle = %greaterthan;			

			$IPCline[ %exs[%x] ] = %greaterthan;
		}
		return %nexttitle + 1;
	}
		

	function IPCGuiDestroy() {
		if (isObject(IPCGui)) {
			playGui.remove(IPCGui);
			IPCGui.delete();
		}
	}


	function IPCCreateLine(%x, %Flag, %Name, %Armor, %Pack, %Objective) {
		if (isObject(IPCGui)) {
			IPCGui.Flag[%x] = new GuiBitmapCtrl() {
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				bitmap = "flag.png";
				position = "0 " @ (%x*16);
				extent = "15 15";
				border = "0";
				visible = %Flag;
			};
			IPCGui.add(IPCGui.Flag[%x]);

			IPCGui.Player[%x] = new GuiTextCtrl() {
				profile = "GuiTextObjHudLeftProfile";
				position = "18 " @ (%x*16);
				extent = "75 15";
				text = %Name;
			};
			IPCGui.add(IPCGui.Player[%x]);

			IPCGui.Armor[%x] = new GuiTextCtrl() {
				profile = "GuiTextObjHudLeftProfile";
				position = "96 " @ (%x*16);
				extent = "8 15";
				text = %Armor;
			};
			IPCGui.add(IPCGui.Armor[%x]);

			IPCGui.Pack[%x] = new GuiBitmapCtrl() {
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				bitmap = %Pack @ ".png";
				position = "107 " @ (%x*16);
				extent = "15 15";
				border = "0";
				visible = "1";
			};
			IPCGui.add(IPCGui.Pack[%x]);

			IPCGui.Objective[%x] = new GuiTextCtrl() {
				profile = "GuiTextObjHudLeftProfile";
				position = "125 " @ (%x*16);
				extent = "65 15";
				text = %Objective;
			};
			IPCGui.add(IPCGui.Objective[%x]);
		}
	}


	function IPCGuiCreate() {
		
		IPCGuiDestroy();

		%extentY = getWord(outerChatHud.extent, 1);

		$IPCGui = new GuiControl(IPCGui){
			horizSizing = "right";
			vertSizing = "top";
			position = 0 @ " " @ (%extentY+10);
			extent = "205 " @ (($IPCMaxplayers + 5) * 16);
			minExtent = "8 8";
			visible = "1";
			opaque = false;
		};
		playGui.add($IPCGUi);
		

		IPCGui.Attacking = new GuiTextCtrl() {
				profile = "GuiTextObjGreenLeftProfile";
				position = "0 0";
				extent = "205 15";
				text = "Attacking:";
		};
		IPCGui.add($IPCGUi.Attacking);

		IPCGui.Defending = new GuiTextCtrl() {
				profile = "GuiTextObjGreenLeftProfile";
				position = "0 16";
				extent = "205 15";
				text = "Defending:";
		};
		IPCGui.add($IPCGUi.Defending);

		IPCGui.Deploying = new GuiTextCtrl() {
				profile = "GuiTextObjGreenLeftProfile";
				position = "0 32";
				extent = "205 15";
				text = "Deploying:";
		};
		IPCGui.add($IPCGUi.Deploying);

		IPCGui.Repairing = new GuiTextCtrl() {
				profile = "GuiTextObjGreenLeftProfile";
				position = "0 48";
				extent = "205 15";
				text = "Repairing:";
		};
		IPCGui.add($IPCGUi.Repairing);

		IPCGui.Needs = new GuiTextCtrl() {
				profile = "GuiTextObjGreenLeftProfile";
				position = "0 64";
				extent = "205 15";
				text = "Needs:";
		};
		IPCGui.add($IPCGUi.Needs);

		IPCDisplayAll();
	}

};

activatePackage(IPC);
$IPCGuiBind = "false";
$IPCVersion = "0.8b";

$IPCMyTeam = "";
$IPCMyPack = "";
$IPCMyLoadout = "";

$IPCMaxPlayers = 15; // Effectively Max 16 (0->15) (Space Constraints in 640x480)
